---
title: 'Window: resize event'
slug: Web/API/Window/resize_event
tags:
  - API
  - Reference
  - Web
  - Window
  - events
  - resize
---
<div>{{APIRef}}</div>

<p><span class="seoSummary">The <strong><code>resize</code></strong> event fires when the document view (window) has been resized.</span></p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("UIEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("GlobalEventHandlers.onresize", "onresize")}}</td>
  </tr>
 </tbody>
</table>

<p>In some earlier browsers it was possible to register <code>resize</code> event handlers on any HTML element. It is still possible to set <code>onresize</code> attributes or use {{domxref("EventTarget.addEventListener", "addEventListener()")}} to set a handler on any element. However, <code>resize</code> events are only fired on the {{domxref("Window", "window")}} object (i.e. returned by {{domxref("document.defaultView")}}). Only handlers registered on the <code>window</code> object will receive <code>resize</code> events.</p>

<p>There is a proposal to allow all elements to be notified of resize changes. See <a href="https://wicg.github.io/ResizeObserver/">Resize Observer</a> to read the draft document, and <a href="https://github.com/WICG/ResizeObserver/issues">GitHub issues</a> to read the on-going discussions.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Window_size_logger">Window size logger</h3>

<p>The following example reports the window size each time it is resized. Bear in mind that since the example is running in an <code>&lt;iframe&gt;</code>, you'll need to actually get the <code>&lt;iframe&gt;</code> to resize before you see an effect.</p>

<pre class="brush: html">&lt;p&gt;Resize the browser window to fire the &lt;code&gt;resize&lt;/code&gt; event.&lt;/p&gt;
&lt;p&gt;Window height: &lt;span id="height"&gt;&lt;/span&gt;&lt;/p&gt;
&lt;p&gt;Window width: &lt;span id="width"&gt;&lt;/span&gt;&lt;/p&gt;</pre>

<pre class="brush: js">const heightOutput = document.querySelector('#height');
const widthOutput = document.querySelector('#width');

function reportWindowSize() {
  heightOutput.textContent = window.innerHeight;
  widthOutput.textContent = window.innerWidth;
}

window.onresize = reportWindowSize;</pre>

<p>{{EmbedLiveSample("Window_size_logger")}}</p>

<h3 id="addEventListener_equivalent">addEventListener equivalent</h3>

<p>You could set up the event handler using the <code><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener()</a></code> method:</p>

<pre class="brush: js">window.addEventListener('resize', reportWindowSize);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM3 Events', '#event-type-resize', 'resize')}}</td>
   <td>{{Spec2('DOM3 Events')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('CSSOM View', '#resizing-viewports', 'resize')}}</td>
   <td>{{Spec2('CSSOM View')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.resize_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("GlobalEventHandlers.onresize")}}</li>
</ul>
